{ KOL MCK } // Do not remove this line!
{$DEFINE KOL_MCK}
unit Unit1;

interface

{$IFDEF KOL_MCK}
uses Windows, Messages, ShellAPI, KOL, KOLGRushControls {$IFNDEF KOL_MCK}, mirror, Classes, Controls, mckControls, mckObjs, Graphics,  mckCtrls,  mckRbControls, MCKGRushControls {$ENDIF (place your units here->)};
{$ELSE}
{$I uses.inc}
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs;
{$ENDIF}

type
  {$IFDEF KOL_MCK}
  {$I MCKfakeClasses.inc}
  {$IFDEF KOLCLASSES} TForm1 = class; PForm1 = TForm1; {$ELSE OBJECTS} PForm1 = ^TForm1; {$ENDIF CLASSES/OBJECTS}
  {$IFDEF KOLCLASSES}{$I TForm1.inc}{$ELSE} TForm1 = object(TObj) {$ENDIF}
    Form: PControl;
  {$ELSE not_KOL_MCK}
  TForm1 = class(TForm)
  {$ENDIF KOL_MCK}
    KOLProject1: TKOLProject;
    KOLForm1: TKOLForm;
    OSD1: TKOLOpenSaveDialog;
    ODD1: TKOLOpenDirDialog;
    GRushPanel1: TKOLGRushPanel;
    Panel2: TKOLGRushPanel;
    CheckBox2: TKOLGRushCheckBox;
    EditBox3: TKOLEditBox;
    Label2: TKOLLabel;
    EditBox4: TKOLEditBox;
    ListBox1: TKOLListBox;
    EditBox1: TKOLEditBox;
    Label1: TKOLLabel;
    Label3: TKOLLabel;
    Label4: TKOLLabel;
    Button4: TKOLGRushButton;
    Button2: TKOLGRushButton;
    Button3: TKOLGRushButton;
    Button5: TKOLGRushButton;
    CheckBox1: TKOLGRushCheckBox;
    Button1: TKOLGRushButton;
    RadioBox1: TKOLGRushRadioBox;
    RadioBox2: TKOLGRushRadioBox;
    CheckBox3: TKOLGRushCheckBox;
    Panel1: TKOLGRushPanel;
    EditBox2: TKOLEditBox;
    procedure Button1Click(Sender: PObj);
    procedure ListBox1SelChange(Sender: PObj);
    procedure Button2Click(Sender: PObj);
    procedure Button4Click(Sender: PObj);
    procedure CheckBox1Click(Sender: PObj);
    procedure Button5Click(Sender: PObj);
    procedure Button3Click(Sender: PObj);
    procedure RadioBox2Click(Sender: PObj);
    procedure Label4Click(Sender: PObj);
    procedure KOLForm1FormCreate(Sender: PObj);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

    ProcessState= Record
        Ratio: double;
        mW,mH: integer;
        Count: Integer;
        Path: String;
        Zoomed: boolean;
        SasOr: boolean;
        Smode: boolean;
        SaveRat: boolean;
        Stoped: boolean;
    end;


var
  Form1 {$IFDEF KOL_MCK} : PForm1 {$ELSE} : TForm1 {$ENDIF} ;
  Running: Boolean;
  PS:ProcessState;

{$IFDEF KOL_MCK}
procedure NewForm1( var Result: PForm1; AParent: PControl );
{$ENDIF}


implementation

uses Unit2;

{$IFNDEF KOL_MCK} {$R *.DFM} {$ENDIF}

{$IFDEF KOL_MCK}
{$I Unit1_1.inc}
{$ENDIF}


procedure TForm1.Button1Click(Sender: PObj);
begin
    if ODD1.Execute then begin
        Editbox1.Text:= ODD1.Path;
    end;
end;

procedure TForm1.ListBox1SelChange(Sender: PObj);
var     i:integer;
        enb:boolean;
begin
    enb:=false;
    for i:= 0 to listbox1.Count do
        if listbox1.ItemSelected[i] then enb:=true;
    button3.Enabled:=enb;
end;

procedure TForm1.Button2Click(Sender: PObj);
var     STR:String;
        path:String;
begin
    if OSD1.Execute then begin
        STR := OSD1.FileName;
        OSD1.FileName := '';
        if StrRScan(PChar(STR), #13) = nil then begin
            ListBox1.Add(STR);
        end else begin
            Path := Parse(STR, #13)+'\';
            while StrLen(PChar(STR)) <> 0 do
                ListBox1.Add(Path + Parse(STR, #13));
        end;
        Label3.Text := Int2Str(listbox1.Count) + ' files';
        Button4.Enabled := true;
    end;
end;

procedure TForm1.Button4Click(Sender: PObj);
begin
    PS.Zoomed:= RadioBox1.Checked;
    if PS.Zoomed then begin
        PS.ratio:=Str2Double(EditBox2.Text);
        if PS.Ratio <= 0  then begin
            MessageBox(Form.Handle, 'Zoom must be greate then zero.', 'Easy to size', MB_ICONASTERISK);
            exit;
        end;
    end else begin
        PS.mW:=str2int(Editbox3.Text);
        if PS.mW <=0 then begin
            MessageBox(Form.Handle, 'Width must be greate then zero.', 'Easy to size', MB_ICONASTERISK);
            exit;
        end;
        PS.mH:=str2int(Editbox4.Text);
        if PS.mW <=0 then begin
            MessageBox(Form.Handle, 'Height must be greate then zero.', 'Easy to size', MB_ICONASTERISK);
            exit;
        end;
    end;
    PS.Stoped := False;
    PS.Count := Form1.Listbox1.Count;
    PS.SasOr := CheckBox1.Checked;
    PS.SaveRat := CheckBox2.Checked;
    PS.Smode := CheckBox3.Checked;
    PS.Path := EditBox1.Text;
    if PS.Path[length(PS.Path)]<>'\' then
        PS.Path := PS.Path + '\';

    if (not PS.SasOr) and (not kol.DirectoryExists(PS.Path)) then begin
        if MessageBox(Form.Handle, 'Create output folder?', 'Easy to size', MB_ICONQUESTION or MB_YESNO)=IDYES then begin
            if not kol.CreateDir(PS.Path) then begin
                MessageBox(Form.Handle, 'Can not create folder!', 'Easy to size', MB_ICONASTERISK);
                exit;
            end end
        else exit;
    end;

    if PS.Smode then begin
        if MessageBox(Form.Handle, 'You select "silence mode".'#13
            + 'If will be files with coincide names, they will be rewriten automaticaly.'#13
            + 'Do you want to continue?', 'Easy to size', MB_ICONINFORMATION or MB_YESNO)=IDNO then
            exit;
    end;

    RunProcess(PS);
end;

procedure TForm1.CheckBox1Click(Sender: PObj);
begin
    if CheckBox1.Checked then begin
        EditBox1.Enabled:= false;
        Button1.Enabled:= false;
    end else begin
       EditBox1.Enabled:= true;
       Button1.Enabled:= true;
    end;
end;

procedure TForm1.Button5Click(Sender: PObj);
begin
    ListBox1.Clear;
    Button4.Enabled:=false;
    Label3.Text:= Int2Str(listbox1.Count) + ' files';
end;

procedure TForm1.Button3Click(Sender: PObj);
var     i:integer;
begin
    i:=0;
    while i < ListBox1.Count do begin
        if Listbox1.ItemSelected[i] then begin
            Listbox1.Delete(i);
            dec(i);
        end;
        inc(i);
    end;
    if ListBox1.Count = 0 then
        Button4.Enabled := False;
    Button3.Enabled := False;
    Label3.Text:= Int2Str(listbox1.Count) + ' files';
end;

procedure TForm1.RadioBox2Click(Sender: PObj);
var     zoom: boolean;
begin
    zoom := RadioBox1.Checked;
    EditBox2.Enabled := zoom;
    EditBox3.Enabled := not zoom;
    EditBox4.Enabled := not zoom;
    CheckBox2.Enabled := not zoom;
    Panel1.Visible := zoom;
    Panel2.Visible := not zoom;
end;
                                                       
procedure TForm1.Label4Click(Sender: PObj);
begin
    ShellExecute(0, 'open', 'mailto:homm86@mail.ru?subject=Easy%20to%20Size%20Support', nil, nil, SW_SHOWNORMAL);
end;

procedure TForm1.KOLForm1FormCreate(Sender: PObj);
var     _temp: array [0..MAX_PATH] of char;
begin
    GetModuleFileName(hinstance, @_temp, MAX_PATH);
    EditBox1.Text := ExtractFilePath(_temp);
end;

end.























