{ KOL MCK } // Do not remove this line!
{$DEFINE KOL_MCK}
unit Unit2;

interface                          

{$IFDEF KOL_MCK}
uses Windows, Messages, ShellAPI, KOL, KOLGRushControls {$IFNDEF KOL_MCK}, mirror, Classes, Controls, mckControls, mckObjs, Graphics,  mckCtrls,  mckRbControls, MCKGRushControls{$ENDIF (place your units here->)}, Unit1, KOLJanFXcut, tinyJPGGIFBMP, tinyPNG;
{$ELSE}
{$I uses.inc}
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, mirror;
{$ENDIF}

type
  {$IFDEF KOL_MCK}
  {$I MCKfakeClasses.inc}
  {$IFDEF KOLCLASSES} TForm2 = class; PForm2 = TForm2; {$ELSE OBJECTS} PForm2 = ^TForm2; {$ENDIF CLASSES/OBJECTS}
  {$IFDEF KOLCLASSES}{$I TForm2.inc}{$ELSE} TForm2 = object(TObj) {$ENDIF}
    Form: PControl;
  {$ELSE not_KOL_MCK}
  TForm2 = class(TForm)
  {$ENDIF KOL_MCK}
    KOLForm1: TKOLForm;
    Timer1: TKOLTimer;
    GRushPanel1: TKOLGRushPanel;
    Label1: TKOLLabel;
    Label2: TKOLLabel;
    Label3: TKOLLabel;
    Label4: TKOLLabel;
    Label5: TKOLLabel;
    Label6: TKOLLabel;
    Label7: TKOLLabel;
    CheckBox1: TKOLGRushCheckBox;
    CheckBox2: TKOLGRushCheckBox;
    ProgressBar1: TKOLGRushProgressBar;
    Button1: TKOLGRushButton;
    procedure Button1Click(Sender: PObj);
    procedure KOLForm1Close(Sender: PObj; var Accept: Boolean);
    procedure CheckBox1Click(Sender: PObj);
    procedure Timer1Timer(Sender: PObj);
  private
    { Private declarations }
  public
    ProcessThread: PThread;
    Time: DWORD;
    Function ProcessFunction (Sender: PThread): Integer;
    procedure ProcessThreadDestroed ( Sender: PObj );
    { Public declarations }
  end;

var
  Form2 {$IFDEF KOL_MCK} : PForm2 {$ELSE} : TForm2 {$ENDIF} ;

{$IFDEF KOL_MCK}
procedure NewForm2( var Result: PForm2; AParent: PControl );
{$ENDIF}

procedure RunProcess (const PS: ProcessState);

implementation

{$IFNDEF KOL_MCK} {$R *.DFM} {$ENDIF}

{$IFDEF KOL_MCK}
{$I Unit2_1.inc}
{$ENDIF}

procedure RunProcess (const PS: ProcessState);
begin
    NewForm2(form2, Form1.Form);
    With Form2^ do begin
        ProgressBar1.MaxProgress := Form1.ListBox1.Count;
        ProcessThread := NewThread;
        ProcessThread.ThreadPriority := THREAD_PRIORITY_LOWEST;
        ProcessThread.OnExecute := ProcessFunction;
        ProcessThread.Data := @PS;
        ProcessThread.OnDestroy := ProcessThreadDestroed;
        ProcessThread.AutoFree := true;
        ProcessThread.Resume;
        Time := GetTickCount;
        Timer1.Enabled := True;
        Form1.Form.Visible := false;
        Form2.Button1.Color := $D9CABD;
        Form.Show;
    end;
end;

procedure TForm2.ProcessThreadDestroed( Sender: PObj );
begin
    ProcessThread := nil;
    if Form2.CheckBox2.Checked then
        Form2.Form.Close;
end;

Function TForm2.ProcessFunction (Sender: PThread): Integer;
var     PS: ^ProcessState;
        i: integer;
        ToFile: String;
        FromFile: String;
        BMP: PBitMap;
        B: PBitMap;
        nW,nH: Integer;
        ImageRat: Double;
        Stream: PStream;
        {_tt: DWORD;
        j:integer; }
begin
    PS := Sender.Data;

    for i:= 0 to PS.Count - 1 do begin
        if PS.Stoped then
            Continue;
        FromFile := form1.listbox1.Items[i];
        ToFile := FromFile;
        Label2.Caption := int2str(i+1) + ' of ' + int2str(PS.Count) + ' files';
        Label4.Caption := ToFile;
        Label5.Caption := 'Loading image...';

        {_tt := GetTickCount();
        For j := 0 to 9 do begin
            tinyLoadPNG(BMP, FromFile);
            Free_and_Nil(BMP);
        end;
        MessageBox(0, Pchar(int2str(GetTickCount -_tt)), nil, 0); }

        if StrLComp_NoCase(PChar(ExtractFileExt(FromFile)), '.png', 4) = 0 then begin
            Stream := NewReadFileStream(FromFile);
            tinyLoadPNG(BMP, Stream);
            Stream.Free;
        end else
            tinyLoadJPGGIFBMPFile(BMP, FromFile);

        if BMP <> nil then begin
            //*************
            if PS.SasOr then
                ToFile := Copy( ToFile, 1, Length( ToFile ) - Length( ExtractFileExt( ToFile ) ) ) + '.bmp'
            else
                ToFile:= PS.Path + ExtractFileNameWOext(ToFile) + '.bmp';
            //*************
            if PS.Zoomed then begin
                nW:= Trunc(BMP.Width * PS.Ratio);
                nH:= Trunc(BMP.Height * PS.Ratio);
            end else begin
                if PS.SaveRat then begin
                    ImageRat := BMP.Width / BMP.Height;
                    if (PS.mW / PS.mH) < ImageRat then begin
                        nW := PS.mW;
                        nH := Trunc( nW / ImageRat);
                    end else begin
                        nH := PS.mH;
                         nW := Trunc( nH * ImageRat);
                    end;
                end else begin
                    nW := PS.mW;
                    nH := PS.mH;
                end;
            end;
            Label5.Caption := 'Resizing (' + int2str(BMP.Width) + 'x'
                + int2str(BMP.Height) + ') -> (' + int2str(nW) + 'x'
                + int2str(nH) + ').';
            //*************
            B := NewBitMap(nW, nH);
            Strecth(BMP, B, Lanczos3Filter, 3.0);
            //*************
            if Kol.FileExists(ToFile) then begin
                if not PS.Smode then begin
                    if MessageBox(Form.Handle, 'File is already exist. Do you want to overwrite', 'Easy to size',MB_ICONQUESTION or MB_YESNO)=IDYES then
                        if windows.DeleteFile(PChar(ToFile))=false then
                            MessageBox(Form.Handle, 'Can not delete file.', 'Easy to size', MB_ICONASTERISK)
                        else
                            B.SaveToFile(ToFile);
                end else
                    if windows.DeleteFile(PChar(ToFile))=true then
                        B.SaveToFile(ToFile);
            end else
                B.SaveToFile(ToFile);
            //*************
            B.Free;
            BMP.Free;
        end else
            if not PS.Smode then
                MessageBox(Form.Handle, 'Can not load image. File may not exist or have unsuported format. ', 'Easy to size', MB_ICONHAND);
        ProgressBar1.Progress := ProgressBar1.Progress+1;
    end;

    if PS.Stoped then begin
        Button1.Enabled := true;
        Label5.Caption := 'Terminated succesful. ' + Label2.Caption + ' was converted';
    end else
        Label5.Caption := 'Operation complite succesful. All files was converted.';
    Button1.Caption := 'Close';
    Label4.Caption := '';
    ProgressBar1.Visible := false;
    CheckBox1.Enabled := false;
    CheckBox2.Enabled := false;
    Result:= 0;
end;

procedure TForm2.Button1Click(Sender: PObj);
begin
    PS.Stoped := True;
    Button1.Caption := 'terminating';
    Button1.Enabled := false;
    CheckBox1.Enabled := false;
    if ProcessThread = nil then
        Form.Close;
end;

procedure TForm2.KOLForm1Close(Sender: PObj; var Accept: Boolean);
begin
    accept := ProcessThread = nil;
    if accept then begin
        Form1.Form.Visible := True;
        ProcessThread.Free;
    end;
end;

procedure TForm2.CheckBox1Click(Sender: PObj);
begin
    if CheckBox1.Checked then begin
        ProcessThread.Suspend;
        Button1.Enabled := false;
    end else begin
        ProcessThread.Resume;
        Button1.Enabled := true;
    end;

end;

procedure TForm2.Timer1Timer(Sender: PObj);
var     NewTime: DWORD;
        STemp: String;
        SResult: String;
begin
    if ProcessThread <> nil then begin
        NewTime := GetTickCount - Time;
        Str((NewTime div 3600000):2, STemp);
        if STemp[1]=' ' then
            STemp[1]:='0';
        SResult := STemp + ':';
        Str(((NewTime div 60000) mod 24):2, STemp);
        if STemp[1]=' ' then
            STemp[1]:='0';
        SResult := SResult + STemp + ':';
        Str(((NewTime div 1000) mod 60):2, STemp);
        if STemp[1]=' ' then
            STemp[1]:='0';
        Label7.Caption := SResult + STemp;
    end else
        Timer1.Enabled := false;
end;

end.












